﻿package com.gycsabesz.huntitdown {
	
	import com.gycsabesz.huntitdown.ai.EnemyPlaneAI;
	import com.gycsabesz.huntitdown.controller.plane.EnemyPlaneController;
	import com.gycsabesz.huntitdown.controller.MenuController;
	import com.gycsabesz.huntitdown.controller.plane.PlaneController;
	import com.gycsabesz.huntitdown.controller.weaponry.RocketLauncherController;
	import com.gycsabesz.huntitdown.model.GameModel;
	import com.gycsabesz.huntitdown.model.MenuModel;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	import com.gycsabesz.huntitdown.model.plane.PlaneModelImpl;
	import com.gycsabesz.huntitdown.model.plane.PlayerPlaneModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.MachineGunModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.RocketLauncherModel;
	import com.gycsabesz.huntitdown.view.Playground;
	import com.gycsabesz.huntitdown.view.bg.Background;
	import com.gycsabesz.huntitdown.view.explosion.FireParticle;
	import com.gycsabesz.huntitdown.view.explosion.PlaneExplosionFire;
	import com.gycsabesz.huntitdown.view.explosion.SmokeParticle;
	import com.gycsabesz.huntitdown.view.hud.InfoText;
	import com.gycsabesz.huntitdown.view.hud.item.ItemLife;
	import com.gycsabesz.huntitdown.view.hud.item.ItemScore;
	import com.gycsabesz.huntitdown.view.hud.life.LifeHud;
	import com.gycsabesz.huntitdown.view.menu.MenuContainer;
	import com.gycsabesz.huntitdown.view.menu.bg.BackgroundImage;
	import com.gycsabesz.huntitdown.view.menu.bg.BackgroundImageRotator;
	import com.gycsabesz.huntitdown.view.menu.pages.PageMainMenu;
	import com.gycsabesz.huntitdown.view.planes.KeyboardControlledPlaneTa152C;
	import com.gycsabesz.huntitdown.view.planes.PlaneTa152C;
	import com.gycsabesz.huntitdown.view.weaponry.gun.RocketLauncher;
	
	import flash.display.MovieClip;
	
	/**
	 * Entry point of the application.
	 */
	public class Engine extends MovieClip {
		public function Engine(){		
			// create menu
			createMenu();
		}
		
		/**
		 * Creates the menu and let the user to interact. 
		 */
		public function createMenu():void{
			var menuModel:MenuModel = new MenuModel();
			var menuController:MenuController = new MenuController(menuModel);
			var menuView:MenuContainer = new MenuContainer(menuModel, menuController);
			
			menuController.setView(menuView);
			menuController.gotoMainMenu();
			
			menuView.x = stage.stageWidth / 2;
			menuView.y = stage.stageHeight / 2;
			menuView.background = true;
			
			this.addChild(menuView);
		}
	}
	
}
