package com.gycsabesz.huntitdown.controller.item
{
	import com.gycsabesz.huntitdown.controller.plane.PlaneController;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	import com.gycsabesz.huntitdown.view.hud.item.Item;
	import com.gycsabesz.huntitdown.view.planes.PlaneTa152C;

	/**
	 * Base class for all controllers of items.
	 */
	public class AbstractItemController
	{
		protected var view:Item;
		
		protected var planeController:PlaneController;
		
		public function AbstractItemController()
		{
		}
		
		public function setView(view:Item):void{
			this.view = view;
		}
		
		public function setPlaneController(planeController:PlaneController):void{
			this.planeController = planeController;
		}
		
		public function moveItem():void{
			if (planeController.getModel().isActive() && view.hitTestObject(planeController.getView())){
				if (itemCollected()){
					view.remove();
					return;
				}
			}
			
			if (view.x < 0){
				view.remove();
				return;
			}
			
			view.x -= 2;
		}
		
		/**
		 * <p>Will be called when the specified plane collects the actual item.
		 * 
		 * <p>abstract-method: override and implement in child classes
		 */
		public function itemCollected():Boolean{
			return false;
		}
	}
}