package com.gycsabesz.huntitdown.controller.plane
{
	import com.gycsabesz.huntitdown.event.PlaneEvent;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	import com.gycsabesz.huntitdown.model.plane.PlaneModelImpl;
	import com.gycsabesz.huntitdown.view.GameView;
	
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	
	/**
	 * Controller of enemy planes
	 */
	public class EnemyPlaneController extends AbstractPlaneController
	{
		public function EnemyPlaneController(planeModel:PlaneModel, gameView:GameView)
		{
			super(planeModel, gameView);
		}
		
		override protected function checkActualPosition():void{
			// stage width and height
			var xMin:Number = planeView.width / 2;
			var yMin:Number = planeView.height / 2;
			var xMax:Number = gameView.playground.width - xMin;
			var yMax:Number = gameView.playground.height - yMin;			
			
			// stay inside screen verically
			if (planeView.y > yMax)
				planeView.y = yMax;
			else if (planeView.y < yMin)
				planeView.y = yMin;

			// remove plane if outside from the screen			
			if (planeView.x + planeView.width / 2 < gameView.playground.x) {
				planeView.remove();
			}			
		}
		
		override protected function planeDestoryed():void{
		}
		
		override protected function planeHasNoMoreLife():void{
			(planeModel as EventDispatcher).removeEventListener(PlaneEvent.ARMOR_TOTALLY_DESTROYED, planeModel_armorTotallyDestroyedHandler);
			(planeModel as EventDispatcher).removeEventListener(PlaneEvent.CHANGED_LIFE, planeModel_changedLifeHandler);
			getView().remove();
		}
	}
}