package com.gycsabesz.huntitdown.controller.plane
{
	import com.gycsabesz.huntitdown.controller.weaponry.MachineGunController;
	import com.gycsabesz.huntitdown.controller.weaponry.RocketLauncherController;
	import com.gycsabesz.huntitdown.event.InfoTextEvent;
	import com.gycsabesz.huntitdown.event.InfoTextLineEvent;
	import com.gycsabesz.huntitdown.model.GameModel;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.MachineGunModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.RocketLauncherModel;
	import com.gycsabesz.huntitdown.view.GameView;
	import com.gycsabesz.huntitdown.view.hud.InfoTextLine;
	import com.gycsabesz.huntitdown.view.planes.PlaneTa152C;
	import com.gycsabesz.huntitdown.view.weaponry.gun.MachineGun;
	import com.gycsabesz.huntitdown.view.weaponry.gun.RocketLauncher;
	
	import flash.display.MovieClip;

	/**
	 * Controller of user's plane.
	 */
	public class PlaneController extends AbstractPlaneController
	{
		public function PlaneController(planeModel:PlaneModel, gameView:GameView)
		{
			super(planeModel, gameView);
		}
		
		override protected function checkActualPosition():void{
			// stage width and height
			var xMin:Number = planeView.width / 2;
			var yMin:Number = planeView.height / 2;
			var xMax:Number = gameView.playground.width - xMin;
			var yMax:Number = gameView.playground.height - yMin;			
			
			// stay inside screen
			if (planeView.x > xMax) {
				planeView.x = xMax;
			} else if (planeView.x < xMin){
				planeView.x = xMin;
			}
			
			if (planeView.y > yMax)
				planeView.y = yMax;
				
			else if (planeView.y < yMin)
				planeView.y = yMin;				
		}
		
		override protected function planeDestoryed():void{
			if (planeModel.getLife() > 0){
				planeModel.setActive(false);
				
				var infoTextLine:InfoTextLine = new InfoTextLine("3", "2", "1", "GO!");
				infoTextLine.addEventListener(InfoTextLineEvent.PLAYING_FINISHED, nextRoundInfoTextLine_playingFinishedHandler, false, 0, true);
				gameView.hudContainer.addChild(infoTextLine);
				infoTextLine.x = gameView.playground.width / 2;
				infoTextLine.y = gameView.playground.height / 2;
			}
		}
		
		protected function nextRoundInfoTextLine_playingFinishedHandler(e: InfoTextLineEvent):void{
			e.target.removeEventListener(InfoTextLineEvent.PLAYING_FINISHED, nextRoundInfoTextLine_playingFinishedHandler);
			planeModel.setActive(true);
		}
		
		override protected function planeHasNoMoreLife():void{
			planeModel.setActive(false);
			
			GameModel.getInstance().gameFailed();
			
			var infoTextLine:InfoTextLine = new InfoTextLine("Game Over!", "Best Luck Next Time!");
			infoTextLine.addEventListener(InfoTextLineEvent.PLAYING_FINISHED, gameOverInfoTextLine_playingFinishedHandler, false, 0, true);
			gameView.hudContainer.addChild(infoTextLine);
			infoTextLine.x = gameView.playground.width / 2;
			infoTextLine.y = gameView.playground.height / 2
		}
		
		protected function gameOverInfoTextLine_playingFinishedHandler(e: InfoTextLineEvent):void{
			e.target.removeEventListener(InfoTextLineEvent.PLAYING_FINISHED, gameOverInfoTextLine_playingFinishedHandler);
			GameModel.getInstance().gameDeactivated();
		}
	}
}