package com.gycsabesz.huntitdown.controller.weaponry
{
	import com.gycsabesz.huntitdown.model.weaponry.gun.GunModel;
	import com.gycsabesz.huntitdown.view.GameView;
	import com.gycsabesz.huntitdown.view.weaponry.gun.Gun;
	
	import flash.display.MovieClip;

	/**
	 * Abstract super class of gun implementations.
	 */
	public class GunControllerImpl
	{
		protected var gameView:GameView;
		protected var model:GunModel;
		protected var view:Gun;
		
		public function GunControllerImpl(model:GunModel, gameView:GameView)
		{
			this.model = model;
			this.gameView = gameView;
		}
		
		/**
		 * Set gun's view.
		 */
		public function setView(view:Gun):void{
			this.view = view;
			this.view.visible = false;
		}
		
		/**
		 * Direction of this gun. -1 means right to left, 1 means left to right.
		 */
		public function setDirection(direction:Number):void{
			this.model.setDirection(direction);
		}
		
		/**
		 * Get gun's model.
		 */
		public function getModel():GunModel{
			return model;
		}
	}
}