package com.gycsabesz.huntitdown.controller.weaponry
{
	import com.gycsabesz.huntitdown.event.GunEvent;
	import com.gycsabesz.huntitdown.model.weaponry.bullet.MachineGunBulletModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.MachineGunModel;
	import com.gycsabesz.huntitdown.view.GameView;
	import com.gycsabesz.huntitdown.view.Playground;
	import com.gycsabesz.huntitdown.view.weaponry.bullet.MachineGunBullet;
	
	import flash.display.MovieClip;
	import flash.events.TimerEvent;
	import flash.external.ExternalInterface;
	import flash.geom.Point;
	import flash.utils.Timer;

	/**
	 * Machine gun controller
	 */
	public class MachineGunController extends GunControllerImpl implements GunController 
	{		
		protected var fireTimer:Timer;
		protected var canFire:Boolean = true;
		
		public function MachineGunController(model:MachineGunModel, gameView:GameView)
		{
			super(model, gameView);
			
			model.addEventListener(GunEvent.CHANGED_FIRING_RATE, model_changeHandler);
			
			model_changeHandler(null);
		}
		
		protected function model_changeHandler(e: GunEvent):void{
			if (fireTimer != null){
				fireTimer.stop();
				fireTimer.removeEventListener(TimerEvent.TIMER, fireTimer_timerHandler, false);
			}
			
			fireTimer = new Timer(model.getFiringRate(), 1);
			fireTimer.addEventListener(TimerEvent.TIMER, fireTimer_timerHandler, false, 0, true);			
		}
		
		protected function fireTimer_timerHandler(e: TimerEvent):void{
			canFire = true;
		}
		
		public function fire():void{
			if (canFire){
				if (model.hasAmmo()){
					var machineGunBulletModel:MachineGunBulletModel = new MachineGunBulletModel(this.model as MachineGunModel);
					var bulletController:BulletController = new BulletController(machineGunBulletModel, gameView);
					var bulletView:MachineGunBullet = new MachineGunBullet(bulletController);
					
					bulletController.setView(bulletView);
					
					gameView.gameObjectsContainer.addChild(bulletView);
					bulletView.x = this.view.localToGlobal(new Point(0,0)).x;
					bulletView.y = this.view.localToGlobal(new Point(0,0)).y;
	
					// decrease ammo
					model.decreaseAmmo();
				}
				
				// restart the timer
				canFire = false;
				fireTimer.start()
			}
		}
		
		public function startFire():void{
			if (model.hasAmmo()){
				this.view.visible = true;
			}
		}
		
		public function stopFire():void{
			this.view.visible = false;	
		}
	}
}