package com.gycsabesz.huntitdown.controller.weaponry
{
	import com.gycsabesz.huntitdown.event.GunEvent;
	import com.gycsabesz.huntitdown.model.weaponry.bullet.MachineGunBulletModel;
	import com.gycsabesz.huntitdown.model.weaponry.bullet.RocketLauncherRocketModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.MachineGunModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.RocketLauncherModel;
	import com.gycsabesz.huntitdown.view.GameView;
	import com.gycsabesz.huntitdown.view.Playground;
	import com.gycsabesz.huntitdown.view.menu.bg.FadingImageLoader;
	import com.gycsabesz.huntitdown.view.weaponry.bullet.MachineGunBullet;
	import com.gycsabesz.huntitdown.view.weaponry.bullet.RocketLauncherRocket;
	import com.gycsabesz.huntitdown.view.weaponry.gun.Gun;
	
	import flash.display.MovieClip;
	import flash.events.TimerEvent;
	import flash.external.ExternalInterface;
	import flash.geom.Point;
	import flash.utils.Timer;

	/**
	 * Rocket launcher controller.
	 */
	public class RocketLauncherController extends GunControllerImpl implements GunController 
	{		
		public function RocketLauncherController(model:RocketLauncherModel, gameView:GameView)
		{
			super(model, gameView);
		}
		
		public function fire():void{
			if (model.hasAmmo()){
				var rocketLauncherRocketModel:RocketLauncherRocketModel = new RocketLauncherRocketModel(this.model as RocketLauncherModel);
				var bulletController:BulletController = new BulletController(rocketLauncherRocketModel, gameView);
				var bulletView:RocketLauncherRocket = new RocketLauncherRocket(bulletController);
				
				bulletController.setView(bulletView);
				
				gameView.gameObjectsContainer.parent.addChild(bulletView);
				bulletView.x = this.view.localToGlobal(new Point(0,0)).x;
				bulletView.y = this.view.localToGlobal(new Point(0,0)).y;
				
				model.decreaseAmmo();
			}
		}
		
		override public function setView(view:Gun):void{
			super.setView(view);
			this.view.visible = true;
		}
		
		public function startFire():void{
			this.view.visible = false;
		}
		
		public function stopFire():void{
		}
	}
}