﻿package com.gycsabesz.huntitdown.model.plane{
	import com.gycsabesz.huntitdown.event.PlaneEvent;
	import com.gycsabesz.huntitdown.model.weaponry.bullet.MachineGunBulletModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.MachineGunModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.RocketLauncherModel;
	
	import flash.events.EventDispatcher;

	public class PlaneModelImpl extends EventDispatcher implements PlaneModel {
		protected var armor:Number = 0;
		
		protected var maxArmor:Number = 0;
		
		protected var topSpeed:Number = 0;
		
		protected var acceleration:Number = 0;

		protected var machineGun1:MachineGunModel;
		
		protected var machineGun2:MachineGunModel;
		
		protected var rocketLauncher1:RocketLauncherModel;
		
		protected var lifeCount:Number = 0;
		
		protected var maxLifeCount:Number = 0;
		
		protected var score:Number = 0;		
		
		protected var _active:Boolean = true;
		
		public function PlaneModelImpl(){	
		}
		
		public function getTopSpeed():Number{
			return this.topSpeed;
		}
		
		public function setTopSpeed(topSpeed:Number):void{
			this.topSpeed = topSpeed;
			
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_TOP_SPEED));
		}
		
		public function getAcceleration():Number{
			return this.acceleration;
		}
		
		public function setAcceleration(acceleration:Number):void{
			this.acceleration = acceleration;
			
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_ACCELERATION));
		}
		
		public function increaseArmor(additionalArmor:Number):void{
			setArmor(armor + additionalArmor);
		}
		
		public function decreaseArmor(minusArmor:Number):void{
			setArmor(armor - minusArmor);
		}
		
		public function setArmor(armor:Number):void{
			this.armor = Math.max(0, Math.min(armor, maxArmor));

			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_ARMOR));
			
			if (this.armor == 0){
				dispatchEvent(new PlaneEvent(PlaneEvent.ARMOR_TOTALLY_DESTROYED));
			}
		}
		
		public function getArmor():Number{
			return armor;
		}
		
		public function increaseMaxArmor(additionalMaxArmor:Number):void{
			setMaxArmor(maxArmor + additionalMaxArmor);
		}
		
		public function setMaxArmor(maxArmor:Number):void{
			this.maxArmor = maxArmor;
			this.armor = Math.min(armor, maxArmor);
			
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_MAX_ARMOR));
		}
		
		public function getMaxArmor():Number{
			return maxArmor;
		}
		
		public function setMachineGun1(machineGun:MachineGunModel):void{
			this.machineGun1 = machineGun;
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_MACHINE_GUN_1));
		}
		
		public function getMachineGun1():MachineGunModel{
			return machineGun1;
		}
		
		public function setMachineGun2(machineGun:MachineGunModel):void{
			this.machineGun2 = machineGun;
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_MACHINE_GUN_2));
		}
		
		public function getMachineGun2():MachineGunModel{
			return machineGun2;
		}
		
		public function setRocketLauncher1(rocketLauncher:RocketLauncherModel):void{
			this.rocketLauncher1 = rocketLauncher;
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_ROCKET_LAUNCHER));
		}
		
		public function getRocketLauncher1():RocketLauncherModel{
			return rocketLauncher1;
		}
		
		public function decreaseLife():void{
			setLife(Math.max(0, lifeCount - 1));
		}
		
		public function increaseLife():void{
			setLife(Math.min(maxLifeCount, lifeCount + 1));
		}
		
		public function setLife(lifeCount: Number):void{
			this.lifeCount = Math.max(0, Math.min(lifeCount, maxLifeCount));
			
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_LIFE));
		}
		
		public function getLife():Number{
			return this.lifeCount;
		}
		
		public function increaseMaxLife():void{
			setMaxLife(maxLifeCount + 1);
		}
		
		public function setMaxLife(maxLife:Number):void{
			this.maxLifeCount = maxLife;
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_MAX_LIFE));
		}
		
		public function getMaxLife():Number{
			return maxLifeCount;
		}		
		
		public function setScore(score:Number):void{
			this.score = score;
			
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_SCORE));
		}
		
		public function getScore():Number{
			return this.score;
		}
		
		public function increaseScore(additionalScore:Number):void{
			setScore(score + additionalScore);
		}
		
		public function setActive(value:Boolean):void{
			if (this._active == value){
				return;
			}
			
			this._active = value;
			dispatchEvent(new PlaneEvent(PlaneEvent.CHANGED_STATE));
		}
		
		public function isActive():Boolean{
			return _active;
		}
		
	}
}