package com.gycsabesz.huntitdown.model.weaponry.gun
{
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;

	/**
	 * Holds the data of a specified gun
	 */
	public interface GunModel
	{
		/**
		 * Maximum ammo of this gun
		 */
		function setMaxAmmo(maxAmmo:Number):void;
		
		/**
		 * Returns the maximum ammo of this gun
		 */
		function getMaxAmmo():Number;
		
		/**
		 * Decrease the amount of ammo by 1
		 */
		function decreaseAmmo():void;
		
		/**
		 * Increase the amount of ammo by 1
		 */
		function increaseAmmo():void;
		
		/**
		 * Removes the specified amount of ammo from this gun
		 */
		function removeAmmo(ammo:Number):void;

		/**
		 * Add ammo to this gun
		 */
		function addAmmo(ammo:Number):void;
		
		/**
		 * Sets the ammo
		 */
		function setAmmo(ammo:Number):void;
		
		/**
		 * Returns the number of ammo of this gun
		 */
		function getAmmo():Number;
		
		/**
		 * Sets the firing rate
		 */
		function setFiringRate(firingRate:Number):void;
		
		/**
		 * Returns the rate of fire
		 */
		function getFiringRate():Number;
		
		/**
		 * Specify whether this gun is endless or not
		 */
		function setInfinite(infinite:Boolean):void;
		
		/**
		 * Returns true if this gun has endless ammo, false otherwise
		 */
		function isInfinite():Boolean;
		
		/**
		 * Returns the hit point (damage) of this gun
		 */
		function getHitPoint():Number;
		
		/**
		 * Sets the hit point (damage) of this gun
		 */
		function setHitPoint(hitPoint:Number):void;
		
		/**
		 * Sets the speed of bullett
		 */
		function setBulletSpeed(ammoBullet:Number):void;
		
		/**
		 * Returns the speed of bullett
		 */
		function getBulletSpeed():Number;
		
		/**
		 * Returns true if there is ammo to fire, false otherwise
		 */
		function hasAmmo():Boolean;
		
		/**
		 * Horizontal direction of the gun. 1 or -1.
		 */
		function getDirection():Number;
			
		/**
		 * Set the direction of the gun. 1 or -1.
		 */
		function setDirection(direction:Number):void;
		
		/**
		 * Sets the plane of this gun.
		 */
		function setPlaneModel(planeModel:PlaneModel):void
			
		/**
		 * Returns the plane of this gun.
		 */
		function getPlaneModel():PlaneModel;
	}
}