package com.gycsabesz.huntitdown.model.weaponry.gun
{
	import com.gycsabesz.huntitdown.event.GunEvent;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	
	import flash.events.EventDispatcher;

	public class GunModelImpl extends EventDispatcher implements GunModel
	{
		protected var ammo:Number = 0;
		protected var maxAmmo:Number;
		protected var firingRate:Number;
		protected var hitPoint:Number;
		protected var infinite:Boolean;
		protected var bulletSpeed:Number;
		protected var direction:Number;
		protected var planeModel:PlaneModel;
		
		public function GunModelImpl(planeModel:PlaneModel, ammo:Number, firingRate:Number, hitPoint:Number, bulletSpeed:Number, infinite:Boolean)
		{
			super();
			
			this.planeModel = planeModel;
			this.ammo = ammo;
			this.firingRate = firingRate;
			this.hitPoint = hitPoint;
			this.infinite = infinite;
			this.bulletSpeed = bulletSpeed;
		}
		
		public function decreaseAmmo():void
		{
			removeAmmo(1);
		}
		
		public function increaseAmmo():void
		{
			addAmmo(1);
		}
		
		public function removeAmmo(ammo:Number):void
		{
			setAmmo(Math.max(0, this.ammo - ammo));
		}
		
		public function addAmmo(ammo:Number):void
		{
			setAmmo(this.ammo + ammo);
		}
		
		public function setAmmo(ammo:Number):void
		{
			if (!isNaN(maxAmmo)){
				ammo = Math.min(ammo, maxAmmo);
			}
			this.ammo = ammo;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_AMMO));
		}
		
		public function getAmmo():Number
		{
			return ammo;
		}
		
		public function setMaxAmmo(maxAmmo:Number):void{
			this.maxAmmo = maxAmmo;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_MAX_AMMO));
		}
		
		public function getMaxAmmo():Number{
			return maxAmmo;
		}
		
		public function setFiringRate(firingRate:Number):void
		{
			this.firingRate = firingRate;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_FIRING_RATE));
		}
		
		public function getFiringRate():Number
		{
			return firingRate;
		}
		
		public function setInfinite(infinite:Boolean):void
		{
			this.infinite = infinite;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_INFINITE));
		}
		
		public function isInfinite():Boolean
		{
			return infinite;
		}
		
		public function getHitPoint():Number
		{
			return hitPoint;
		}
		
		public function setHitPoint(hitPoint:Number):void
		{
			this.hitPoint = hitPoint;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_HIT_POINT));
		}
		
		
		public function getBulletSpeed():Number
		{
			return bulletSpeed;
		}
		
		public function setBulletSpeed(bulletSpeed:Number):void
		{
			this.bulletSpeed = bulletSpeed;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_BULLET_SPEED));
		}		
		
		public function hasAmmo():Boolean{
			return infinite || ammo > 0;
		}
		
		public function getDirection():Number{
			return direction;
		}
		
		public function setDirection(direction:Number):void{
			this.direction = direction;
			dispatchEvent(new GunEvent(GunEvent.CHANGED_DIRECTION));
		}
		
		public function setPlaneModel(planeModel:PlaneModel):void{
			this.planeModel = planeModel;
		}
		
		public function getPlaneModel():PlaneModel{
			return planeModel;
		}
	}
}