package com.gycsabesz.huntitdown.view
{
	import com.gycsabesz.huntitdown.controller.GameController;
	import com.gycsabesz.huntitdown.view.bg.Background;
	import com.gycsabesz.huntitdown.view.hud.InfoText;
	import com.gycsabesz.huntitdown.view.menu.MenuButton;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class GameView extends MovieClip
	{
		protected var background:Background;
		
		protected var _playground:Playground;
		
		protected var _gameObjectsContainer:MovieClip;

		protected var _itemsContainer:MovieClip;
		
		protected var _hudContainer:MovieClip;
		
		protected var _btnExit:MenuButton;
		
		protected var _controller:GameController;
		
		public function GameView()
		{
			_hudContainer = new MovieClip();
			_gameObjectsContainer = new MovieClip();
			_itemsContainer = new MovieClip();
			
			background = new Background();
			background.x = background.y = 0;	
			
			_playground = new Playground();
			_playground.x = _playground.y = 0;			
			
			_btnExit = new MenuButton();
			_btnExit.setLabel("Exit");
			_btnExit.x = 43;
			_btnExit.y = _btnExit.height / 2 + 8;
			_btnExit.addEventListener(MouseEvent.CLICK, btnExit_clickHandler);
			
			addChild(playground);
			addChild(background);
			addChild(_itemsContainer);
			addChild(_gameObjectsContainer);
			addChild(_hudContainer);
			addChild(_btnExit);
			
			addEventListener(Event.ADDED_TO_STAGE, this_addedToStageHandler);
		}
		
		protected function this_addedToStageHandler(e:Event):void{
			var infoText:InfoText = new InfoText("Hunt It Down!");
			addChild(infoText);
			infoText.x = stage.stageWidth / 2;
			infoText.y = stage.stageHeight / 2;
		}
		
		protected function btnExit_clickHandler(e:MouseEvent):void {
			controller.deactivateGame();
		}
		
		public function get playground():Playground{
			return _playground;
		}
		
		public function get gameObjectsContainer():MovieClip{
			return _gameObjectsContainer;
		}
		
		public function get hudContainer():MovieClip{
			return _hudContainer;
		}
		
		public function get itemsContainer():MovieClip{
			return _itemsContainer;
		}
		
		public function get controller():GameController{
			return _controller;
		}
		
		public function set controller(v:GameController):void{
			this._controller = v;
		}
	}
}