package com.gycsabesz.huntitdown.view.bg
{
	import flash.display.MovieClip;
	import flash.events.Event;

	/**
	 * Cloud. Instance of this class will be added to the background.
	 */
	public class Cloud extends MovieClip
	{
		protected var container:MovieClip;
		
		protected var randomizedSpeed:Number;
		
		/**
		 * Creates a new instance.
		 */
		public function Cloud(container:MovieClip)
		{
			this.container = container;
			setup();
			addEventListener(Event.ENTER_FRAME, this_enterFrameHandler, false, 0, true);
		}
		
		/**
		 * Move the cloud right to left, or reset the position of the cloud if it is out of range.
		 */
		public function this_enterFrameHandler(e:Event):void{
			if (x < - this.width - Math.random() * 100){
				setup();			
			} else {
				x -= randomizedSpeed;
			}
		}
		
		/**
		 * Randomize the speed, scale and position of this cloud.
		 */
		protected function setup():void{
			// randomize the shape of this cloud
			gotoAndStop( int( ( Math.random() * this.totalFrames ) + 1 ) );
			
			y = Math.random() * container.height;
			x = container.width + this.width;
			
			scaleX = Math.random() * 0.8;
			scaleY = scaleX + ((Math.random() - 0.5) * 0.2);
			
			alpha = Math.max(0.85, scaleX + ((Math.random() - 0.5) * 0.4));
			
			randomizedSpeed = scaleX * 10;			
		}
	}
}