﻿package com.gycsabesz.huntitdown.view.explosion {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	
	/**
	 * Smoke particle item.
	 */
	public class SmokeParticleItem extends MovieClip {
		protected var vx:Number;
		protected var vy:Number;
		
		protected var alphaDelta:Number;
		protected var scaleDelta:Number;
		
		/**
		 * Creates a new smoke particle item.
		 */
		public function SmokeParticleItem(
			alphaMax:Number, 
			alphaDelta:Number, 
			scaleDelta:Number,
			scaleInitial:Number,
			speed:Number,
			movementX:Number) : void
		{
			this.alphaDelta = alphaDelta;
			this.scaleDelta = scaleDelta;
			
			alpha = Math.random() * alphaMax;
			vx = (Math.random() - 0.5) * movementX;
			vy = Math.random() * speed - 5;
			scaleX = scaleY = Math.random() * scaleInitial;
			addEventListener(Event.ENTER_FRAME, this_enterFrameHandler, false, 0, true);
		}
		
		protected function this_enterFrameHandler(e:Event) : void
		{
			alpha -= alphaDelta;
			y += vy;
			x += vx;
			scaleX = scaleY += scaleDelta * Math.random();
			
			if (alpha < 0)
				removeSelf();
		}
		
		protected function removeSelf() : void
		{
			removeEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
			parent.removeChild(this);
		}
	}
	
}
