package com.gycsabesz.huntitdown.view.hud.item
{
	import com.gycsabesz.huntitdown.controller.item.AbstractItemController;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	
	/**
	 * Graphic of game items.
	 */
	public class Item extends MovieClip
	{
		public var itemAnimated:MovieClip;
		
		public static const ITEM_LIFE:String = "life";
		public static const ITEM_ARMOR:String = "armor";
		public static const ITEM_ROCKET:String = "rocket";
		public static const ITEM_SPEED:String = "speed";
		public static const ITEM_SCORE:String = "score";
		
		protected var type:String;
		
		protected var controller:AbstractItemController;		
		
		/**
		 * <p>Creates a new item graphic with the specified type.
		 * <p>Type determines the image which will be shown. (e.g.: armor, rocket, score, ...)
		 */
		public function Item(type:String){
			this.type = type;
			itemAnimated.itemGraphic.gotoAndStop(type);
			this.addEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
		}
		
		protected function this_enterFrameHandler(e:Event):void{
			controller.moveItem();
		}

		/**
		 * Set the controller of this view.
		 */
		public function setController(controller:AbstractItemController):void{
			this.controller = controller;
		}	
		
		public function remove():void{
			removeEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
			if (this.parent != null){
				this.parent.removeChild(this);			
			}
		}
	}
}