package com.gycsabesz.huntitdown.view.hud.life
{
	import com.gycsabesz.huntitdown.event.PlaneEvent;
	import com.gycsabesz.huntitdown.model.plane.PlaneModel;
	import com.gycsabesz.huntitdown.model.plane.PlaneModelImpl;
	
	import flash.display.MovieClip;

	/**
	 * Display object which shows the number of lifes of the user.
	 */
	public class LifeCounter extends MovieClip
	{
		public var life1:LifeIco;
		public var life2:LifeIco;
		public var life3:LifeIco;
		
		protected var model:PlaneModelImpl;
		
		public function setModel(model:PlaneModelImpl):void{
			if (this.model != null){
				model.removeEventListener(PlaneEvent.CHANGED_LIFE, model_changeHandler);
			}
			
			this.model = model;
			model.addEventListener(PlaneEvent.CHANGED_LIFE, model_changeHandler);
		}
		
		/**
		 * Will be called every time when the life of user's plane is changed.
		 */
		protected function model_changeHandler(e:PlaneEvent):void{
			setLifeNumber(model.getLife());
		}
		
		/**
		 * Change the value of life counter.
		 */
		public function setLifeNumber(lifeNumber:Number):void{
			if (lifeNumber >= 3){
				life3.turnOn();
			} else {
				life3.turnOff();
			}
			
			if (lifeNumber >= 2){
				life2.turnOn();
			} else {
				life2.turnOff();
			}
			
			if (lifeNumber >= 1){
				life1.turnOn();
			} else {
				life1.turnOff();
			}
		}
	}
}