package com.gycsabesz.huntitdown.view.hud.life
{
	import com.gycsabesz.huntitdown.event.PlaneEvent;
	import com.gycsabesz.huntitdown.model.plane.PlaneModelImpl;
	
	import flash.display.MovieClip;

	/**
	 * Shows the actual state of the armor of user's plane.
	 */
	public class LifeProgressBar extends MovieClip
	{
		public var barMask:MovieClip;
		
		protected var model:PlaneModelImpl;
		
		/**
		 * Related plane model. LifeProgressBar will show the armor of the specified model.
		 */
		public function setModel(model:PlaneModelImpl):void{
			if (this.model != null){
				model.removeEventListener(PlaneEvent.CHANGED_ARMOR, model_changeHandler);
			}
			
			this.model = model;
			model.addEventListener(PlaneEvent.CHANGED_ARMOR, model_changeHandler);
		}
	
		/**
		 * Will be called every time, when the armor of the user's plane is changed.
		 */ 
		protected function model_changeHandler(e:PlaneEvent):void{
			setPercentage(model.getArmor() / model.getMaxArmor() * 100);
		}
		
		/**
		 * Set the percentage of this progress bar.
		 */
		public function setPercentage(percent:Number):void {
			barMask.scaleX = percent / 100;
		}
	}
}