﻿package com.gycsabesz.huntitdown.view.menu {
	
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	/**
	 * Menu button, with mouse over, mouse out and labeling functionality
	 */
	public class MenuButton extends MovieClip {
		public var buttonLabel:TextField;
		
		protected var label:String;
		
		public function MenuButton() {
			this.buttonMode = true;
			this.mouseChildren = false;
			
			this.stop();
			
			this.addEventListener(MouseEvent.MOUSE_OVER, this_mouseOverHandler);
			this.addEventListener(MouseEvent.MOUSE_OUT, this_mouseOutHandler);
			this.addEventListener(MouseEvent.MOUSE_DOWN, this_mouseOutHandler);
			this.addEventListener(MouseEvent.MOUSE_UP, this_mouseOverHandler);
		}
		
		/**
		 * Called when the mouse is over the button.
		 */
		protected function this_mouseOverHandler(e:MouseEvent):void{
			this.gotoAndStop("mouseOver");
			setLabel(label);
		}
		
		/**
		 * Called when the mouse is out of the button.
		 */
		protected function this_mouseOutHandler(e:MouseEvent):void{
			this.gotoAndStop("mouseOut");
			setLabel(label);
		}
		
		/**
		 * Set the label of the button.
		 */
		public function setLabel(label:String):void{
			this.label = label;
			this.buttonLabel.text = this.label;
		}
	}
}
