package com.gycsabesz.huntitdown.view.menu.bg
{	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	/**
	 * <p>Handles menu background images.
	 * <p>URL of images are loaded from lib/resources.xml
	 */
	public class BackgroundImage extends MovieClip
	{
		protected var bgImageRotator:BackgroundImageRotator;
		
		public function BackgroundImage(w:Number, h:Number)
		{	
			bgImageRotator = new BackgroundImageRotator(w, h);
			bgImageRotator.x = bgImageRotator.y = 0;
			this.addChild(bgImageRotator);	
			
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, xmlLoader_completeHandler);
			xmlLoader.load(new URLRequest("lib/resources.xml"));
			
		}
		
		/**
		 * When the xml file is loaded this callback method will be called and all images 
		 * will be added to the background image rotator instance.
		 */
		protected function xmlLoader_completeHandler(e:Event):void{
			XML.ignoreWhitespace = true;
			
			var resources:XML = new XML(e.target.data);
			var i:Number;
			for (i = 0; i < resources.background_images.image.length(); i++){
				var imageName:String = resources.background_images.image[i].text();
				bgImageRotator.addImage(imageName);
			}
			
			bgImageRotator.playRotating();			
		}
	}
}