package com.gycsabesz.huntitdown.view.menu.bg
{
	import com.gycsabesz.huntitdown.view.bg.Background;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.BlurFilter;
	import flash.geom.ColorTransform;
	import flash.net.FileFilter;
	import flash.net.FileReference;
	import flash.net.URLRequest;
	import flash.utils.Timer;
	
	/**
	 * Handles the rotating of images. Actual image will be faded-out and then the next image will be faded-in.
	 */
	public class BackgroundImageRotator extends MovieClip
	{
		protected var images:Array = new Array();
		protected var interval:Number = 5000;
		
		protected var rotateTimer:Timer;
		protected var imageNr = 0;
		
		protected var nextImageLoader:FadingImageLoader;
		protected var actualImageLoader:FadingImageLoader;
		
		protected var w:Number, h:Number;
		
		public function BackgroundImageRotator(w:Number, h:Number){
			super();
			
			this.w = w;
			this.h = h;
			
			setInterval(interval);
			
			this.filters = [new BlurFilter(5, 5, BitmapFilterQuality.MEDIUM)];
			
			//var color:ColorTransform = new ColorTransform();
			//color.redOffset   = -0;
			//color.greenOffset = -0;
			//color.blueOffset  = -0;
			
			//this.transform.colorTransform = color; 
		}
		
		/**
		 * Add image to the image rotator.
		 */
		public function addImage(url:String):void{
			images.push(url);
		}
		
		/**
		 * Sets the interval which should be elapsed between the changing of images.
		 */
		public function setInterval(interval:Number){
			rotateTimer = new Timer(interval);
			this.interval = interval;
		}
		
		/**
		 * Start timer.
		 */
		public function playRotating():void{
			// set first image
			rotateTimer_timerHandler(null);
			
			// start timer
			rotateTimer.start();
			rotateTimer.addEventListener(TimerEvent.TIMER, rotateTimer_timerHandler, false, 0, true);			
		}
		
		/**
		 * Stop timer.
		 */
		public function pauseRotating():void{
			// stop timer
			rotateTimer.stop();
			rotateTimer.removeEventListener(TimerEvent.TIMER, rotateTimer_timerHandler, false);		
		}
		
		/**
		 * Change image to the next one.
		 */
		protected function rotateTimer_timerHandler(e:TimerEvent):void{
			if (images.length <= 0) return;
			
			if (imageNr >= images.length) {
				imageNr = 0;
			}
			
			changeImage(imageNr++);
		}
		
		protected function changeImage(nr:Number){
			var image:String = images[nr];

			nextImageLoader = new FadingImageLoader(new URLRequest(image));
			nextImageLoader.addEventListener(FadingImageLoader.EVENT_IMAGE_LOADED, nextImageLoader_imageLoadedHandler, false, 0, true);
			nextImageLoader.addEventListener(FadingImageLoader.EVENT_IMAGE_SHOWED, nextImageLoader_imageShowedHandler, false, 0, true);
			
			nextImageLoader.x = nextImageLoader.y = 0;
			
			this.addChild(nextImageLoader);
		}
	
		protected function nextImageLoader_imageLoadedHandler(e:Event):void{		
			nextImageLoader.width = w;
			nextImageLoader.height = h;
			
			parent.width = this.width = w;
			parent.height = this.height = h;
		}
		
		protected function nextImageLoader_imageShowedHandler(e:Event):void{		
			if (actualImageLoader != null){
				this.removeChild(actualImageLoader);
			}
			
			nextImageLoader.removeEventListener(FadingImageLoader.EVENT_IMAGE_SHOWED, nextImageLoader_imageShowedHandler, false);
			actualImageLoader = nextImageLoader;
			nextImageLoader = null;
		}
	}
}