﻿package com.gycsabesz.huntitdown.view.menu.bg {
	import fl.transitions.Tween;
	import fl.transitions.TweenEvent;
	import fl.transitions.easing.Strong;
	
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	
	/**
	 * Loads the specified image and fade-in it.
	 */
	public class FadingImageLoader extends MovieClip {
		public static var EVENT_IMAGE_LOADED:String = "IMAGE_LOADED";
		public static var EVENT_IMAGE_SHOWED:String = "IMAGE_SHOWED";
		
		protected var loader:Loader;
		protected var fadeInTween:Tween;
		
		/**
		 * <p>Creates a new fading image loader instance.
		 * <p><b>url</b>: url of the image to be loaded.
		 */
		public function FadingImageLoader(url:URLRequest) {
			super();
			
			this.alpha = 0.0;
			
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loader_completeHandler);
			loader.load(url);
		}
		
		protected function loader_completeHandler(e:Event):void{
			loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, loader_completeHandler);
			
			this.addChild(loader);
			
			dispatchEvent(new Event(EVENT_IMAGE_LOADED));
			
			fadeInTween = new Tween(this, "alpha", Strong.easeIn, 0, 1, 3, true);
			fadeInTween.addEventListener(TweenEvent.MOTION_FINISH, fadeInTween_motionFinishHandler);
		}
		
		protected function fadeInTween_motionFinishHandler(e:TweenEvent):void{
			fadeInTween.removeEventListener(TweenEvent.MOTION_FINISH, fadeInTween_motionFinishHandler);
			
			dispatchEvent(new Event(EVENT_IMAGE_SHOWED));
		}
	}
}