package com.gycsabesz.huntitdown.view.menu.colorchooser
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.geom.ColorTransform;

	/**
	 * Color item which will be added to the color chooser.
	 */
	public class ColorItem extends MovieClip
	{
		protected var r:Number;
		protected var g:Number;
		protected var b:Number;
		
		public function ColorItem(r:Number, g:Number, b:Number)
		{
			this.r = r;	
			this.g = g;	
			this.b = b;	
			
			this.buttonMode = true;
			this.mouseChildren = false;
			
			var square:Sprite = new Sprite();
			addChild(square);
			
			var color:ColorTransform = new ColorTransform();
			color.redOffset = r;
			color.greenOffset = g;
			color.blueOffset = b;
			
			square.graphics.lineStyle(3, 0x333333);
			square.graphics.beginFill(color.color);
			square.graphics.drawRect(0, 0, 20, 20);
			square.graphics.endFill();
			square.x = - square.width / 2;
			square.y = - square.height / 2;
		}
		
		public function getColorTransform():ColorTransform{
			var mul:Number=0.3;
			var ctMul:Number=(1-mul);
			var ctRedOff:Number=Math.round(mul*r);
			var ctGreenOff:Number=Math.round(mul*g);
			var ctBlueOff:Number=Math.round(mul*b);
			var color:ColorTransform = new ColorTransform(ctMul,ctMul,ctMul,1,ctRedOff,ctGreenOff,ctBlueOff,0);
		
			return color;
		}
	}
}