﻿package com.gycsabesz.huntitdown.view.menu.pages {
	
	import com.gycsabesz.huntitdown.controller.MenuController;
	import com.gycsabesz.huntitdown.model.MenuModel;
	import com.gycsabesz.huntitdown.view.menu.MenuButton;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	/**
	 * Menu page: main menu
	 */
	public class PageMainMenu extends MovieClip {
		public var btnNewGame:MenuButton;
		public var btnInstructions:MenuButton;
		public var btnAbout:MenuButton;
		
		protected var controller:MenuController;
		protected var model:MenuModel;

		public function PageMainMenu(model:MenuModel, controller:MenuController) {
			this.model = model;
			this.controller = controller;
			
			this.stop();
			
			btnNewGame.setLabel("Start new game");
			btnNewGame.addEventListener(MouseEvent.CLICK, btnNewGame_clickHandler);
			
			btnInstructions.setLabel("Instructions");
			btnInstructions.addEventListener(MouseEvent.CLICK, btnInstructions_clickHandler);
			
			btnAbout.setLabel("About");	
			btnAbout.addEventListener(MouseEvent.CLICK, btnAbout_clickHandler);
		}
		
		/**
		 * Start new game button is pressed
		 */
		protected function btnNewGame_clickHandler(e:MouseEvent):void{
			controller.gotoStartNewGame();
		}
		
		/**
		 * About button is pressed
		 */
		protected function btnAbout_clickHandler(e:MouseEvent):void{
			controller.gotoAbout();
		}
		
		/**
		 * Instructions button is pressed
		 */
		protected function btnInstructions_clickHandler(e:MouseEvent):void{
			controller.gotoInstructions();
		}
	}
}
