package com.gycsabesz.huntitdown.view.menu.pages {
	
	import com.gycsabesz.huntitdown.controller.MenuController;
	import com.gycsabesz.huntitdown.model.MenuModel;
	import com.gycsabesz.huntitdown.view.menu.MenuButton;
	import com.gycsabesz.huntitdown.view.menu.colorchooser.ColorChooser;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	/**
	 * Menu page: new game
	 */
	public class PageNewGame extends MovieClip {
		public var btnBack:MenuButton;
		public var btnStartNewGame:MenuButton;
		
		protected var controller:MenuController;
		protected var model:MenuModel;
		protected var colorChooser:ColorChooser;
		
		public function PageNewGame(model:MenuModel, controller:MenuController) {
			this.model = model;
			this.controller = controller;
			
			this.stop();
			
			btnBack.setLabel("Back to main menu");
			btnBack.addEventListener(MouseEvent.CLICK, btnBack_clickHandler);
			
			btnStartNewGame.setLabel("Start game");
			btnStartNewGame.addEventListener(MouseEvent.CLICK, btnStartNewGame_clickHandler);
			
			colorChooser = new ColorChooser();
			colorChooser.x = -100;
			colorChooser.y = 195;
			addChild(colorChooser);
		}
		
		/**
		 * Back to main menu button is pressed
		 */
		protected function btnBack_clickHandler(e:MouseEvent):void{
			controller.gotoMainMenu();
		}
		
		/**
		 * Start game button is pressed
		 */
		protected function btnStartNewGame_clickHandler(e:MouseEvent):void{
			controller.startNewGame(colorChooser.getColor());
		}
	}
}