package com.gycsabesz.huntitdown.view.menu.sound
{
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	/**
	 * Background music player. Music URLs are loaded from lib/resources.xml file.
	 */
	public class BackgroundMusic
	{
		protected var loaded:Boolean = false;
		
		protected var sounds:Array;
		protected var pos:Number = 0;
		protected var canPlay:Boolean = false;
		
		protected var channel:SoundChannel;
		protected var transform:SoundTransform;
		
		public function BackgroundMusic()
		{
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.addEventListener(Event.COMPLETE, xmlLoader_completeHandler);
			xmlLoader.load(new URLRequest("lib/resources.xml"));
		}
		
		public function play():void {
			if (canPlay == true){
				return;
			}
			
			canPlay = true;
			start();
		}
		
		public function pause():void {
			if (canPlay == false){
				return;
			}
			
			canPlay = false;
			
			if (channel != null){
				channel.stop();
				channel_soundCompleteHandler(null);
			}
		}
		
		protected function xmlLoader_completeHandler(e:Event):void {
			XML.ignoreWhitespace = true;
			
			sounds = new Array();
			
			var resources:XML = new XML(e.target.data);
			var i:Number;
			for (i = 0; i < resources.menu_musics.music.length(); i++){
				var sound:Music = new Music();
				var soundRequest:URLRequest = new URLRequest(resources.menu_musics.music[i].url.text());
				sound.setRequiredVolume(Number(resources.menu_musics.music[i].volume.text()));
				sound.load(soundRequest);
				sounds.push(sound);
			}
			
			loaded = true;
			start();
		}
		
		protected function getSoundToPlay():Music{
			if (sounds.length <= 0) {
				return null;
			}
			
			if (pos >= sounds.length){
				pos = 0;
			}
			
			return sounds[pos++];
		}
		
		protected function start():void{
			if (loaded && canPlay){
				var sound:Music = getSoundToPlay();
				channel = sound.play(0, 0, new SoundTransform(sound.getRequiredVolume()));
				channel.addEventListener(Event.SOUND_COMPLETE, channel_soundCompleteHandler);
			}
		}
		
		protected function channel_soundCompleteHandler(e:Event):void{
			channel.removeEventListener(Event.SOUND_COMPLETE, channel_soundCompleteHandler);
			start();
		}
	}
}