package com.gycsabesz.huntitdown.view.planes
{
	import com.gycsabesz.huntitdown.controller.plane.PlaneController;
	import com.senocular.utils.KeyObject;
	
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;

	public class KeyboardControlledPlaneTa152C extends PlaneTa152C
	{
		protected var key:KeyObject;
		
		protected var firingMachineGun:Boolean = false;
		
		public function KeyboardControlledPlaneTa152C(controller:PlaneController)
		{
			super(controller);

			addEventListener(Event.ADDED_TO_STAGE, this_addedToStageHandler);
			addEventListener(Event.REMOVED_FROM_STAGE, this_removedFromStageHandler);
		}
		
		public function this_addedToStageHandler(e:Event):void{
			this.key = new KeyObject(stage);
			addEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
		}
		
		public function this_removedFromStageHandler(e:Event):void{
			this.key = null;
		}
		
		public function this_enterFrameHandler(e:Event):void{
			if (key == null){
				return;
			}
			
			if (key.isDown(Keyboard.CONTROL)){
				controller.launchRocketLauncher1();
			}
			
			if (key.isDown(Keyboard.SPACE)) {
				if (!firingMachineGun){
					controller.startFireMachineGun();
				}
				firingMachineGun = true;
				controller.fireMachineGun();
			}
			
			if (!key.isDown(Keyboard.SPACE) && firingMachineGun){
				controller.stopFireMachineGun();
				firingMachineGun = false;
			}
			
			if (key.isDown(Keyboard.UP)){
				controller.moveUpPlane();
			} else if (key.isDown(Keyboard.DOWN)){
				controller.moveDownPlane();
			} else {
				controller.slowDownPlaneVertical();
			}
			
			if (key.isDown(Keyboard.LEFT)){
				controller.moveBackwardPlane();
			} else if (key.isDown(Keyboard.RIGHT)){
				controller.moveForwardPlane();
			} else { 
				controller.slowDownPlaneHorizontal();
			}
		}
		
		override public function remove():void{
			removeEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
			
			removeEventListener(Event.ADDED_TO_STAGE, this_addedToStageHandler);
			removeEventListener(Event.REMOVED_FROM_STAGE, this_removedFromStageHandler);
			
			super.remove();
		}
	}
}