package com.gycsabesz.huntitdown.view.planes
{
	import com.gycsabesz.huntitdown.controller.plane.AbstractPlaneController;
	import com.gycsabesz.huntitdown.event.PlaneEvent;
	
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	
	/**
	 * Abstract base class of planes.
	 */
	public class Plane extends MovieClip
	{	
		protected var controller:AbstractPlaneController;
		
		public function Plane(controller:AbstractPlaneController)
		{
			this.controller = controller;
			(this.controller.getModel() as EventDispatcher).addEventListener(PlaneEvent.CHANGED_STATE, model_changedStateHandler);
		}
		
		/**
		 * When the state of the plane is changed, plane graphic will be paled.
		 */
		protected function model_changedStateHandler(e:PlaneEvent):void{
			if (controller.getModel().isActive()){
				this.alpha = 1.0;
			} else {
				this.alpha = 0.2;
			}
		}
		
		/**
		 * Remove this plane view from the stage.
		 */
		public function remove():void{
			if (parent != null){
				parent.removeChild(this);
			}
		}
		
		/**
		 * Returns the graphic instance which marks the place of the 1st machine gun.
		 */
		public function getMarkerMachineGun1():MovieClip{
			return null;
		}
		
		/**
		 * Returns the graphic instance which marks the place of the 2nd machine gun.
		 */
		public function getMarkerMachineGun2():MovieClip{
			return null;
		}
		
		/**
		 * Returns the graphic instance which marks the place of the 1st rocket launcher gun.
		 */
		public function getMarkerRocketLauncher():MovieClip{
			return null;
		}
	}
}