package com.gycsabesz.huntitdown.view.weaponry.bullet
{
	import com.gycsabesz.huntitdown.controller.weaponry.BulletController;
	import com.gycsabesz.huntitdown.model.weaponry.bullet.BulletModel;
	import com.gycsabesz.huntitdown.model.weaponry.gun.GunModel;
	
	import flash.display.MovieClip;
	import flash.events.Event;
	
	/**
	 * Represents a general bullet.
	 */
	public class Bullet extends MovieClip
	{
		protected var controller:BulletController;
		
		public function Bullet(controller:BulletController) {
			this.controller = controller;
			this.scaleX = this.controller.getModel().getGun().getDirection();
			
			addEventListener(Event.ENTER_FRAME, this_enterFrameHandler, false, 0, true);	
		}
		
		protected function this_enterFrameHandler(e:Event):void{
			this.controller.moveBullet();
		}
		
		/**
		 * Removes the bullet from the stage.
		 */
		public function remove():void{
			removeEventListener(Event.ENTER_FRAME, this_enterFrameHandler);
			if (this.parent != null){
				this.parent.removeChild(this);			
			}
		}
		
		/**
		 * Removes the bullet from the stage and plays the movie clip of the impact.
		 */ 
		public function removeAndPlayHit():void{		
			// create the explosion and remove the bullet
			if (this.parent != null){
				var expl:MachineGunBulletExplosion = new MachineGunBulletExplosion();
				expl.x = this.x;
				expl.y = this.y;
				expl.scaleX = this.controller.getModel().getGun().getDirection();
				
				this.parent.addChild(expl);
			}
			
			remove();
		} 
	}
}